-----------------------------------------------
-- Namespaces
-----------------------------------------------
local _, core = ...;

-----------------------------------------------
-- Global Variables
-----------------------------------------------
datacompiler = {};


function TranslateEquipLoc( ItemEquipLoc, fingerCount, trinketCount, weaponCount )

	if ItemEquipLoc == "INVTYPE_HEAD" then
		return 1;
	elseif ItemEquipLoc == "INVTYPE_NECK" then
		return 2;
	elseif ItemEquipLoc == "INVTYPE_SHOULDER" then
		return 3;
	elseif ItemEquipLoc == "INVTYPE_CLOAK" then
		return 15;
	elseif ItemEquipLoc == "INVTYPE_CHEST" then
		return 5;
	elseif ItemEquipLoc == "INVTYPE_WRIST" then
		return 9;
	elseif ItemEquipLoc == "INVTYPE_HAND" then
		return 10;
	elseif ItemEquipLoc == "INVTYPE_FEET" then
		return 8;
	elseif ItemEquipLoc == "INVTYPE_WAIST" then
		return 6;
	elseif ItemEquipLoc == "INVTYPE_LEGS" then
		return 7;
	elseif ItemEquipLoc == "INVTYPE_FINGER" then
		return 11 + fingerCount;--11,12
	elseif ItemEquipLoc == "INVTYPE_TRINKET" then
		return 13 + trinketCount;--13,14
	elseif ItemEquipLoc == "INVTYPE_WEAPON" then
		return 16 + weaponCount;--19,20
	elseif ItemEquipLoc == "INVTYPE_SHIELD" then
		return 17;
	elseif ItemEquipLoc == "INVTYPE_2HWEAPON" then
		return 16;
	elseif ItemEquipLoc == "INVTYPE_WEAPONMAINHAND" then
		return 16;
	elseif ItemEquipLoc == "INVTYPE_WEAPONOFFHAND" then
		return 17;
	elseif ItemEquipLoc == "INVTYPE_HOLDABLE" then
		return 17;
	elseif ItemEquipLoc == "INVTYPE_RANGED" then
		return 18;
	elseif ItemEquipLoc == "INVTYPE_THROWN" then
		return 18;
	elseif ItemEquipLoc == "INVTYPE_RANGEDRIGHT" then
		return 18;
	elseif ItemEquipLoc == "INVTYPE_RELIC" then
		return 18;
	
	end
	
	return 0;
end


function GetPlayerInfo(unitId)
  if UnitExists(unitId) and UnitIsPlayer(unitId)  then
  
	NotifyInspect(unitId);
	
	--Basic Info
    local playerName = UnitName(unitId);
    local realmName = GetRealmName();
    local playerLevel = UnitLevel(unitId);
	local _,playerRace,_ = UnitRace(unitId);
	local _,playerClass,_ = UnitClass(unitId);	
    local playerHealth = UnitHealthMax(unitId);
	local playerGuild, playerGuildRank = GetGuildInfo(unitId);
	local playerEquipment = "";
	
	if not playerGuild then
		playerGuild = "";
		playerGuildRank = "";
	end
	
	--Talents
	local numTabs = GetNumTalentTabs();
	local talent_info = "";
	local current_max = 0;
	local talent_info = "";
	for t=1, numTabs do	
		
		local numTalents = GetNumTalents(t);
		local pointsInTab = 0;
		for i=1, numTalents do
			name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(t,i);
			pointsInTab = pointsInTab + currentRank;
		end	
		if (pointsInTab > current_max) then
			current_max = pointsInTab;
			talent_info = t;
		end
	end

	--Equipment
	for i = 1, 19, 1 do
		local itemId = GetInventoryItemID(unitId, i);
		local link = GetInventoryItemLink(unitId, i);
		local enchantId = 0;
		local gem1Id = 0;
		local gem2Id= 0;
		local gem3Id = 0;
		local gem4Id = 0;
		
		if not (link == null) then		
			local _, _, Color, Ltype, Id, Enchant, Gem1, Gem2, Gem3, Gem4, Suffix, Unique, LinkLvl, Name = string.find(link, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?");
			enchantId = tonumber(Enchant);
			gem1Id = tonumber(Gem1);
			gem2Id = tonumber(Gem2);
			gem3Id = tonumber(Gem3);
			gem4Id = tonumber(Gem4);
			
			if enchantId == nil then
				enchantId = 0;
			end
		end
			
		if playerEquipment == "" then
			playerEquipment = format("%d:%d:%d:%d:%d", itemId, enchantId, gem1Id, gem2Id, gem3Id, gem4Id);
		else
			playerEquipment = format("%s %d:%d:%d:%d:%d", playerEquipment, itemId, enchantId, gem1Id, gem2Id, gem3Id, gem4Id);

		end
	end
	

		
	-- encode and return info
	return enc(format("%s,%s,%s,%s,%s,%s,%s,%s,%s,%s",
		playerName, realmName, playerLevel, playerRace, playerClass, talent_info, playerEquipment, playerHealth, playerGuild, playerGuildRank));
  end
end


-----------------------------------------------
-- Frames
-----------------------------------------------
function datacompiler:getplayer()
	return GetPlayerInfo("player");
end
